package com.gic.enterprise.context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class RequestContext {
    private ThreadLocal<HttpServletRequest> requestThreadLocal = new ThreadLocal<>();
    private ThreadLocal<HttpServletResponse> responseThreadLocal = new ThreadLocal<>();
    private static RequestContext requestContext = new RequestContext();

    public static RequestContext getContext(){
        return requestContext;
    }

    public void init(HttpServletRequest request, HttpServletResponse response){
        requestThreadLocal.set(request);
        responseThreadLocal.set(response);
    }

    public void destroy(){
        requestThreadLocal.remove();
        responseThreadLocal.remove();
    }

    public HttpServletRequest getRequest(){
        return requestThreadLocal.get();
    }

    public HttpServletResponse getResponse(){
        return responseThreadLocal.get();
    }
}
