package com.gic.enterprise.error;

/**
 * @author zhiwj
 * @date 2019/6/24
 */
public enum ErrorCode implements Error{
    /**
     * 缺少参数
     */
    MISS_PARAMETER("0002", "缺少参数"),
    /**
     * 系统异常
     */
    SYSTEM_ERROR("0003", "系统异常"),
    /**
     * 登录异常
     */
    LOGIN_ERROR("0004", "登录异常"),
    /**
     * 输入参数错误
     */
    PARAMETER_ERROR("0005", "输入参数错误"),


    /**
     * 数据已存在
     */
    DATA_EXISTS("0006", "数据已存在"),
    /**
     * 失效操作失败
     */
    OPERATION_FAILED("0007", "失效操作失败"),

    NOTEXISTS("0008", "记录不存在"),

    NOT_SUPPORT("0009", "不支持文本类型"),
    ENTERPRISE_EMPTY("0010", "企业id不能为空"),
    UNKNOWN_ERROR("9999", "未知错误"),
    LOGIN_ERR("0011", "用户名或密码错误"),
    AUTHCODE_ERR("0012", "验证码异常"),
    AUTHCODE_EXPIRE("0013", "验证码失效"),
    AUTHCODE_MISTAKE("0014", "验证码错误"),
    AUTHCODE_USED("0015", "验证码已经被使用"),
    LOGIN_INVALID("6666", "登录信息失效，请重新登录");


    private String code;
    private String msg;

    private ErrorCode(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public String getCode() {
        return code;
    }


    public String getMsg() {
        return msg;
    }

    @Override
    public String getErrorCode() {
        return code;
    }

    @Override
    public String getErrorMsg() {
        return msg;
    }
}
