package com.gic.enterprise.filter;

import com.alibaba.fastjson.JSON;
import com.gic.enterprise.constants.Constants;
import org.apache.commons.lang.StringUtils;
import org.apache.dubbo.common.constants.CommonConstants;
import org.apache.dubbo.common.extension.Activate;
import org.apache.dubbo.rpc.*;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
import java.util.Map;

@Activate(group = {CommonConstants.PROVIDER})
public class ServiceValidateFilter implements Filter {
    @Override
    public Result invoke(Invoker<?> invoker, Invocation invocation) throws RpcException {
        String token = invocation.getAttachment(Constants.USER_TOKEN);
        RpcContext.getContext();
        if(StringUtils.isNotBlank(token)){
            RpcContext.getContext().setAttachment(Constants.USER_TOKEN, token);
        }
        System.out.println("profilter attachments"+ JSON.toJSONString(invocation.getAttachments()));
        System.out.println("参数："+JSON.toJSONString(invocation.getArguments()));
        Class<?>[] parameterTypes = invocation.getParameterTypes();
        String methodName = invocation.getMethodName();
        Method[] declaredMethods = invoker.getInterface().getDeclaredMethods();
        for(Method method : declaredMethods){
            if(method.getName().equals(methodName) && checkMethodParameter(parameterTypes, method.getParameterTypes())){
                for(int i=0; i<parameterTypes.length; i++){
                    Class<?> parameterType = parameterTypes[i];
                    Annotation[] annotations = parameterType.getAnnotations();

                }
            }
        }
        return invoker.invoke(invocation);
    }

    private boolean checkMethodParameter(Class<?>[] parameterTypes, Class<?>[] parameterTypes2){
        if(parameterTypes.length != parameterTypes2.length){
            return false;
        }
        for(int i=0; i<parameterTypes.length; i++){
            if(!parameterTypes[i].equals(parameterTypes2[i])){
                return false;
            }
        }
        return true;
    }
}
