package com.gic.enterprise.filter;

import com.gic.enterprise.constants.Constants;
import com.gic.enterprise.utils.TokenUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.dubbo.common.constants.CommonConstants;
import org.apache.dubbo.common.extension.Activate;
import org.apache.dubbo.rpc.*;
import org.apache.dubbo.rpc.filter.ConsumerContextFilter;


@Activate(group = {CommonConstants.CONSUMER}, order = -1000)
public class UserTokenFilter implements Filter {
    @Override
    public Result invoke(Invoker<?> invoker, Invocation invocation) throws RpcException {
        String token = invocation.getAttachment(Constants.USER_TOKEN);
        RpcContext rpcContext = RpcContext.getContext();
        if(StringUtils.isNotBlank(token)){
            TokenUtils.set(token);
            RpcContext.getContext().setAttachment(Constants.USER_TOKEN, token);
        }else {
            RpcContext.getContext().setAttachment(Constants.USER_TOKEN, TokenUtils.get());
        }
        try{
            return invoker.invoke(invocation);
        }finally {
            TokenUtils.remove();
        }
    }
}
