package com.gic.enterprise.utils;

import java.util.Random;

/**
 * 生成随机数工具类
 * @ClassName: CreatePasswordAutoUtils 
 * @Description:  
 * @author guojuxing 
 * @date 2019/8/9 4:39 PM 
 */
public class CreateRandomUtils {
    /**
     * 随机生成字母、数字参合的密码
     * @param length 生成多少位数的密码
     * @return
     */
    public static String getStringRandom(int length) {

        String val = "";
        Random random = new Random();
        //length为几位密码
        for (int i = 0; i < length; i++) {
            String charOrNum = random.nextInt(2) % 2 == 0 ? "char" : "num";
            //输出字母还是数字
            if ("char".equalsIgnoreCase(charOrNum)) {
                //输出是大写字母还是小写字母
                int temp = random.nextInt(2) % 2 == 0 ? 65 : 97;
                val += (char) (random.nextInt(26) + temp);
            } else if ("num".equalsIgnoreCase(charOrNum)) {
                val += String.valueOf(random.nextInt(10));
            }
        }
        return val;
    }

    /**
     * 随机生成0-9的数字
     * @Title: generateNumberStr 
     * @Description:
      * @author guojuxing
     * @param length  生成多少位数
     * @return  java.lang.String 
      */
    public static String generateNumberStr(int length) {
        String numberChar = "0123456789";
        StringBuilder sb = new StringBuilder();
        Random random = new Random();
        for (int i = 0; i < length; i++) {
            sb.append(numberChar.charAt(random.nextInt(numberChar.length())));
        }
        return sb.toString();
    }
}
